//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property copyright "ZFS"
#property link      "forexzfs.ru vasbsm@mail.ru skype:vasbsm"

extern int TP_Error=0;//-   , 0 -  
extern int BarSL=20;//  barSL , 0 
extern int blockBarSL=0;//   BarSL  BUY  SELL      MAT, 0 
extern int blockSL=0;//   BUY  SELL       MAT, 0 
extern int order=0;//        MAT, 0 
extern int MaxPos=0;// -    , 0 

extern int pMAH=128;// H 
extern int TFH=0;//  H
extern int shiftMAH=0;// H  
extern int typeMAH=0;// H 
extern int priceMAH=0;// H 

extern int pMAL=128;// L 
extern int TFL=0;//  L
extern int shiftMAL=0;// L  
extern int typeMAL=0;// L 
extern int priceMAL=0;// L 

extern int pMAT=128;// T 
extern int TFT=0;//  T
extern int shiftMAT=0;// T  
extern int typeMAT=0;// T 
extern int priceMAT=0;// T 

extern int    lotM=0;//           maT
extern double lot=0.1;//  
extern int    RoundLot=2;// 

extern int barX=3;// ,            

extern int pipsXH=180;//    ,       
extern int pipsXL=180;//    ,       
extern int pipsXT=0;//    ,      (maT-pipsXT)      (maL+pipsXT)

extern int    BU=0;//   , 0 - 
extern int    SL=0;//
extern int    Magic=666;//
extern int    NumberOfTry=5;//-    
extern int    Slippage=3;//
extern bool   UseSound=true;//  
extern string NameFileSound="ok.wav";//  
extern int    PauseAfterError=3;//  

static datetime TimeN=0;
double MAT,priceSell,priceBuy;
static int matBuy=0,matSell=0;
static int YesBarSLBuy=1,YesSLBuy=1,YesBarSLSell=1,YesSLSell=1,YesOrder=1,
YesBlockSLBuy=1,YesBlockSLSell=1,YesPosBuy=1,YesPosSell=1;

int OrderBU[],NorderBU=0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   if(TFH==0)TFH=Period();if(TFL==0)TFL=Period();if(TFT==0)TFT=Period();
   ArrayResize(OrderBU,1000);ArrayInitialize(OrderBU,0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i;
   int TF=MathMin(TFH,TFL);
   TF=MathMin(TF,TFT);

   datetime TimeC=iTime(NULL,TF,0);
   if(TimeN==0)TimeN=TimeC;
   if(TimeN==TimeC) return(0);

   double MAH=iMA(Symbol(),TFH,pMAH,shiftMAH,typeMAH,priceMAH,0);
   double MAL=iMA(Symbol(),TFL,pMAL,shiftMAL,typeMAL,priceMAL,0);
   MAT=NormalizeDouble(iMA(Symbol(),TFT,pMAT,shiftMAT,typeMAT,priceMAT,0),Digits);
   double BUbuy =MAT-pipsXT*Point;
   double BUsell=MAT+pipsXT*Point;

   priceSell =MAH+pipsXH*Point;
   priceBuy  =MAL-pipsXL*Point;
   double stplvl=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;// 

                                                           //    
   int nBuy=0,nSell=0;datetime minTimeBuy=0,minTimeSell=0;
   double NewTP;
   for(i=OrdersTotal()-1;i>=0;i--)
     {//  
      if(OrderSelect(i,SELECT_BY_POS))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
           {
            if(OrderType()==OP_BUY)
              {
               nBuy++;
               if(minTimeBuy<1 || minTimeBuy<OrderOpenTime())minTimeBuy=OrderOpenTime();
               if(TP_Error<stplvl/Point)NewTP=stplvl/Point;
               if(priceBuy+stplvl>MAT)NewTP=priceBuy+TP_Error*Point;else NewTP=MAT;
               if(TP_Error==0)NewTP=MAT;
               NewTP=NormalizeDouble(NewTP,Digits);
               //Print (NewTP);
               if(MathAbs(NewTP-OrderTakeProfit())>1*Point)
                 {//  
                  Print(" - BUY "+DoubleToStr(NewTP,Digits));
                  ModifyStopTake(0,OrderStopLoss(),NewTP);
                 }
               if(BU!=0 && OrderStopLoss()!=(OrderOpenPrice()+BU*Point) && //
                  Bid>BUbuy && Ask>(OrderOpenPrice()+BU*Point+stplvl))
                 {
                  Print(" BUY "+DoubleToStr(OrderOpenPrice()+BU*Point,Digits));
                  ModifyStopTake(0,OrderOpenPrice()+BU*Point,OrderTakeProfit());
                  OrderBU[NorderBU]=OrderTicket();NorderBU++;
                 }
               if(BarSL!=0 && iBarShift(NULL,0,OrderOpenTime())>=BarSL)
                 {
                  ClosePosBySelect();if(blockBarSL>0)
                    {YesBarSLBuy=0;ClosePositions(NULL,OP_BUY,Magic);}
                 }//BARSL 
              }
            if(OrderType()==OP_SELL)
              {
               nSell++;
               if(minTimeSell<1 || minTimeSell<OrderOpenTime())minTimeSell=OrderOpenTime();
               if(TP_Error<stplvl/Point)NewTP=stplvl/Point;
               if(priceSell-stplvl<MAT)NewTP=priceSell-TP_Error*Point;else NewTP=MAT;
               if(TP_Error==0)NewTP=MAT;
               NewTP=NormalizeDouble(NewTP,Digits);
               if(MathAbs(NewTP-OrderTakeProfit())>1*Point)
                 {// 
                  Print(" - SELL "+DoubleToStr(NewTP,Digits));
                  ModifyStopTake(0,OrderStopLoss(),NewTP);
                 }
               if(BU!=0 && OrderStopLoss()!=(OrderOpenPrice()-BU*Point) && Bid<BUsell && //
                  Bid<(OrderOpenPrice()-BU*Point-stplvl))
                 {
                  Print(" SELL "+DoubleToStr(OrderOpenPrice()-BU*Point,Digits));
                  ModifyStopTake(0,OrderOpenPrice()-BU*Point,OrderTakeProfit());OrderBU[NorderBU]=OrderTicket();NorderBU++;
                 }
               if(BarSL!=0 && iBarShift(NULL,0,OrderOpenTime())>=BarSL)
                 {
                  ClosePosBySelect();if(blockBarSL>0)
                    {YesBarSLSell=0;ClosePositions(NULL,OP_SELL,Magic);}
                 }//BARSL        
              }

           }
        }
     }

   if(MaxPos>0)
     {
      if(MaxPos<=nBuy){YesPosBuy=0;DeleteOrders("",OP_BUYLIMIT,-1,-1,Wheat);DeleteOrders("",OP_BUYSTOP,-1,-1,Wheat);}
      if(MaxPos<=nSell){YesPosSell=0;DeleteOrders("",OP_SELLLIMIT,-1,-1,Wheat);DeleteOrders("",OP_SELLSTOP,-1,-1,Wheat);}
     }

//    MAT  
   datetime timeMAT=iTime(NULL,TFT,iBars(Symbol(),TFT)-1);
   for(i=0;i<iBars(Symbol(),TFT);i++)
     {
      double iMAT=iMA(Symbol(),TFT,pMAT,shiftMAT,typeMAT,priceMAT,i);
      if(iHigh(NULL,TFT,i)>=iMAT && iLow(NULL,TFT,i)<=iMAT)
        {
         timeMAT=iTime(NULL,TFT,i);
         int itimeMAT=iBarShift(NULL,TFT,timeMAT);if(i==0){itimeMAT=0;timeMAT=iTime(NULL,TFT,0);}
         break;
        }
     }
//-- 
   int itimeBuy=iBarShift(NULL,TFT,minTimeBuy);
   int itimeSell=iBarShift(NULL,TFT,minTimeSell);

//Print(itimeMAT,"-",order," ",YesOrder);
   if(itimeMAT-order>0 && order!=0)
     {
      YesOrder=0;DeleteOrders("",OP_BUYLIMIT,-1,-1,Wheat);DeleteOrders("",OP_BUYSTOP,-1,-1,Wheat);
      DeleteOrders("",OP_SELLLIMIT,-1,-1,Wheat);DeleteOrders("",OP_SELLSTOP,-1,-1,Wheat);
     }

//  
   int nOrderH=OrdersHistoryTotal();
   for(i=0;i<nOrderH;i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false)
        {
         Print("      (",GetLastError(),")");break;
        }
      if(OrderOpenTime()>timeMAT && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
        {
         if(OrderType()==OP_BUY)
           {
            nBuy++;
            if(blockSL>0)
              {
               int boolBU=0;
               for(int l=0;l<NorderBU;l++){if(OrderBU[l]==OrderTicket())boolBU=1;break;}
               if(boolBU<1)
                 {
                  YesBlockSLBuy=0;
                  DeleteOrders("",OP_BUYLIMIT,-1,-1,Wheat);DeleteOrders("",OP_BUYSTOP,-1,-1,Wheat);
                  ClosePositions(NULL,OP_BUY,Magic);
                 }
              }
           }//if (minTimeBuy<1||minTimeBuy<OrderOpenTime())minTimeBuy=OrderOpenTime();
         if(OrderType()==OP_SELL)
           {
            nSell++;
            if(blockSL>0)
              {
               boolBU=0;
               for(l=0;l<NorderBU;l++){if(OrderBU[l]==OrderTicket())boolBU=1;break;}
               if(boolBU<1)
                 {
                  YesBlockSLSell=0;
                  DeleteOrders("",OP_SELLLIMIT,-1,-1,Wheat);DeleteOrders("",OP_SELLSTOP,-1,-1,Wheat);
                  ClosePositions(NULL,OP_SELL,Magic);
                 }
              }

           }//if (minTimeSell<0||minTimeSell<OrderOpenTime())minTimeSell=OrderOpenTime();    
        }
     }

// MAT
//Print (itimeMAT);
   if(itimeMAT<=1)
     {
      //Print(666);
      YesBarSLBuy=1;YesSLBuy=1;
      YesBarSLSell=1;YesSLSell=1;
      YesOrder=1;
      YesBlockSLBuy=1;YesBlockSLSell=1;
      YesPosBuy=1;YesPosSell=1;
     }

// 
/*
    if (!fBarX(barX,"SELL",itimeMAT)){
     for(i=OrdersTotal()-1;i>=0;i--){//  
      if(OrderSelect(i,SELECT_BY_POS)){
       if(OrderSymbol()==Symbol()&&OrderMagicNumber()==Magic){
        if(OrderType()==OP_SELLSTOP||OrderType()==OP_SELLLIMIT){
         DeleteOrders("",-1,0,-1,Wheat);
        }}}}}  
    // 
    if (!fBarX(barX,"BUY",itimeMAT)){
     for(i=OrdersTotal()-1;i>=0;i--){//  
      if(OrderSelect(i,SELECT_BY_POS)){
       if(OrderSymbol()==Symbol()&&OrderMagicNumber()==Magic){
        if(OrderType()==OP_BUYSTOP||OrderType()==OP_BUYLIMIT){
         DeleteOrders("",-1,0,-1,Wheat);
        }}}}}     
        */
//if (nSell>0)Print("SELL"+fBarX(barX,"SELL",itimeSell)," ",itimeSell," ",nSell);
//else Print("SELL"+nSell);        

//SELL
   if((nSell<1 || (nSell>0 && fBarX(barX,"SELL",itimeSell-1))) && (Bid<priceSell-stplvl || Bid>priceSell+stplvl))
     {
      int ticketSell=-1;
      for(i=OrdersTotal()-1;i>=0;i--)
        {//  
         if(OrderSelect(i,SELECT_BY_POS))
           {
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
              {
               if(OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT)
                 {
                  ticketSell=OrderTicket();
                 }
              }
           }
        }
      if(ticketSell<1)
        {// 
         //if (OrderOpenPrice()+stplvl>MAT)NewTP=OrderOpenPrice()+TP_Error;else NewTP=MAT;
         //int TP=(priceSell-MAT)/Point;  
         //Print(YesOrder);
         if(Bid>priceSell && YesBarSLSell>0 && YesOrder>0 && YesBlockSLSell>0 && YesPosSell>0)
            fOrderLimit(OP_SELLSTOP,priceSell,fCalculateLot(lotM,nSell+1),SL,TP_Error,Magic);
         if(Bid<priceSell && YesBarSLSell>0 && YesOrder>0 && YesBlockSLSell>0 && YesPosSell>0)
            fOrderLimit(OP_SELLLIMIT,priceSell,fCalculateLot(lotM,nSell+1),SL,TP_Error,Magic);
           }else{// 
         if(YesBarSLSell<1 || YesOrder<0 || YesBlockSLSell<0)DeleteOrders("",-1,ticketSell,-1,Wheat);else
           {
            if(OrderSelect(ticketSell,SELECT_BY_TICKET))
              {
               double _lot=fCalculateLot(lotM,nSell+1);
               // 
               if(MathAbs(_lot-OrderLots())<0.001)
                 {
                  if(MathAbs(OrderOpenPrice()-priceSell)>=1*Point)
                    {
                     if(SL!=0)ModifyLimitOrder(OrderTicket(),priceSell,priceSell+SL*Point,0.0);
                     else ModifyLimitOrder(OrderTicket(),priceSell,0.0,0.0);
                    }

                 }

               else
                 {
                  //if (MathAbs(_lot-OrderLots())>0){// 
                  DeleteOrders("",-1,ticketSell,-1,Wheat);
                  bool Ok=true;
                  for(i=OrdersTotal()-1;i>=0;i--)
                    {//  
                     if(OrderSelect(i,SELECT_BY_POS))
                       {
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
                          {
                           if(OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT)
                             {
                              Ok=false;
                             }
                          }
                       }
                    }
                  if(Ok)
                    { //          
                     //TP=(priceSell-MAT)/Point; 
                     //Print(YesOrder);
                     if(Bid>priceSell && YesBarSLSell>0 && YesOrder>0 && YesBlockSLSell>0 && YesPosSell>0)
                        fOrderLimit(OP_SELLSTOP,priceSell,_lot,SL,TP_Error,Magic);
                     if(Bid<priceSell && YesBarSLSell>0 && YesOrder>0 && YesBlockSLSell>0 && YesPosSell>0)
                        fOrderLimit(OP_SELLLIMIT,priceSell,_lot,SL,TP_Error,Magic);
                    }
                 }//         
              }
           }
        }
     }
//if (nBuy>0)Print(fBarX(barX,"BUY",itimeBuy)," ",itimeBuy," ",nBuy);
//else Print(nBuy);
//BUY
   if((nBuy<1 || (nBuy>0 && fBarX(barX,"BUY",itimeBuy-1))) && (Ask<priceBuy-stplvl || Ask>priceBuy+stplvl))
     {
      int ticketBuy=-1;
      for(i=OrdersTotal()-1;i>=0;i--)
        {//  
         if(OrderSelect(i,SELECT_BY_POS))
           {
            if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
              {
               if(OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT)
                 {
                  ticketBuy=OrderTicket();
                 }
              }
           }
        }
      if(ticketBuy<1)
        { //          
         //TP=(MAT-priceBuy)/Point;  
         //Print(YesOrder);
         if(Ask<priceBuy && YesBarSLBuy>0 && YesOrder>0 && YesBlockSLBuy>0 && YesPosBuy>0)
            fOrderLimit(OP_BUYSTOP,priceBuy,fCalculateLot(lotM,nBuy+1),SL,TP_Error,Magic);
         if(Ask>priceBuy && YesBarSLBuy>0 && YesOrder>0 && YesBlockSLBuy>0 && YesPosBuy>0)
            fOrderLimit(OP_BUYLIMIT,priceBuy,fCalculateLot(lotM,nBuy+1),SL,TP_Error,Magic);
           }else{// 
         if(YesBarSLBuy<1 || YesOrder<0 || YesBlockSLBuy<0)DeleteOrders("",-1,ticketBuy,-1,Wheat);else
           {
            if(OrderSelect(ticketBuy,SELECT_BY_TICKET))
              {
               _lot=fCalculateLot(lotM,nBuy+1);
               // 
               if(MathAbs(_lot-OrderLots())<0.001)
                 {
                  if(MathAbs(OrderOpenPrice()-priceBuy)>=1*Point)
                    {
                     if(SL!=0)ModifyLimitOrder(OrderTicket(),priceBuy,priceBuy-SL*Point,0.0);
                     else ModifyLimitOrder(OrderTicket(),priceBuy,0,0.0);
                    }

                 }
               else
                 {
                  //if (MathAbs(_lot-OrderLots())>0){//  
                  DeleteOrders("",-1,ticketBuy,-1,Wheat);

                  Ok=true;
                  for(i=OrdersTotal()-1;i>=0;i--)
                    {//  
                     if(OrderSelect(i,SELECT_BY_POS))
                       {
                        if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
                          {
                           if(OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT)
                             {
                              Ok=false;
                             }
                          }
                       }
                    }
                  if(Ok)
                    {
                     //TP=(MAT-priceBuy)/Point;  
                     //Print(YesOrder);
                     if(Ask<priceBuy && YesBarSLBuy>0 && YesOrder>0 && YesBlockSLBuy>0 && YesPosBuy>0)
                        fOrderLimit(OP_BUYSTOP,priceBuy,_lot,SL,TP_Error,Magic);
                     if(Ask>priceBuy && YesBarSLBuy>0 && YesOrder>0 && YesBlockSLBuy>0 && YesPosBuy>0)
                        fOrderLimit(OP_BUYLIMIT,priceBuy,_lot,SL,TP_Error,Magic);
                    }
                 } //           
              }
           }
        }
     }

   TimeN=TimeC;
  }
//+------------------------------------------------------------------+
//|                                 |
//| :                                                       |
//|   op     -                                               |
//|   openprice -                                            |
//|   _SL -                                               |
//|   _TP -                                               |
//+------------------------------------------------------------------+
int fOrderLimit(int op,double openprice,double Lots,double _SL,double _TP,int MAGIC)
  {
//fOrderLimit(OP_BUYSTOP,open,Lot,SL,TP,int MAGIC);
   int    err,ticket,minLevel;
   string lsComm=StringConcatenate(Day(),".",Month(),Year()," ",Hour(),":",Minute(),":",Seconds());
   minLevel=MarketInfo(Symbol(),MODE_STOPLEVEL);

//        0
   if((_SL<minLevel)&&(_SL!=0))_SL=minLevel;
   if((_TP<minLevel)&&(_TP!=0))_TP=minLevel;

   if(op==OP_BUYSTOP || op==OP_BUYLIMIT)
     {
      if(_SL>0)_SL=openprice-_SL*Point;
      if(_TP>0)_TP=openprice+_TP*Point;
     }
   if(op==OP_SELLSTOP || op==OP_SELLLIMIT)
     {
      if(_SL>0)_SL=openprice+_SL*Point;
      if(_TP>0)_TP=openprice-_TP*Point;
     }

   for(int it=0; it<NumberOfTry; it++)
     {
      while(!IsTradeAllowed()) Sleep(5000);
      RefreshRates();

      ticket=OrderSend(Symbol(),op,NormalizeDouble(Lots,RoundLot),NormalizeDouble(openprice,Digits),Slippage,
                       NormalizeDouble(_SL,Digits),NormalizeDouble(_TP,Digits),lsComm,MAGIC,0,Green);

      if(ticket>0)
        {
         if(UseSound) PlaySound(NameFileSound);
         break;

           } else {
         err=GetLastError();
         Print("Error(",err,") OpenOrderLimit: ",Error(err),",  ",it);
         Sleep(1000*5);
        }
     }
   return(ticket);
  }
//+------------------------------------------------------------------+
//|   ().                                     |
//+------------------------------------------------------------------+
//| :                                                       |
//|   sy - Symbol ("" -  , "all"-  )      |
//|   op -   OP_BUYSTOP, OP_SELLLIMIT .. (-1)    |
//| _tckt -   ( 0    ,(-1) )|
//|   mn - Magic  (-1)                                  |
//|   cl -                                |
//+------------------------------------------------------------------+
void DeleteOrders(string sy="",int op=-1,int _tckt=-1,int mn=-1,color cl=CLR_NONE)
  {
//DeleteOrders("",-1,0,-1,Wheat);DeleteOrders("",-1,_tckt,-1,Wheat);
   int NOrders,orType,err;
//---
   if(sy=="")sy=Symbol();
   if(_tckt>0 || _tckt==0)NOrders=1;
   else NOrders=OrdersTotal();
//---
   for(int i=NOrders; i>0; i--)
     {
      //---------------       ----------
      for(int cx=0; cx<NumberOfTry; cx++)
        {
         if(_tckt>0 && _tckt!=0)
           {
            //---   
            if(!OrderSelect(_tckt,SELECT_BY_TICKET,MODE_TRADES))
              {
               err=GetLastError();
               Print("Error(",err,") DeleteOrders() -> OrderSelect(): ",Error(err));
               continue;
              }
           }
         //--------------        ---------
         if(_tckt<0)
           {
            if(!OrderSelect(i-1,SELECT_BY_POS,MODE_TRADES))
              {
               err=GetLastError();
               Print("Error(",err,"), DeleteOrders() -> OrderSelect() ",Error(err));
               continue;
              }
           }
         orType=OrderType();
         if((orType==OP_BUYSTOP) || (orType==OP_SELLSTOP) || (orType==OP_BUYLIMIT) || (orType==OP_SELLLIMIT))
           {
            if((sy==OrderSymbol() || sy=="all") && (mn==OrderMagicNumber() || mn<0))
              {
               if((op<0) || (op==orType))
                 {
                  if(OrderDelete(OrderTicket(),cl))
                    {
                     if(UseSound) PlaySound(NameFileSound);
                     break;
                    }
                  else err=GetLastError();
                  Print("Error(",err,") DeleteOrders() -> OrderDelete(): ",Error(err),", try ",cx);

                  if(err==1||err==2||err==3||err==5) break;                      // 1- ,   , 2- , 3- , 5-   
                  if(err==64||err==65||err==133||err==139) break;                // 64- , 65-  , 133- , 139-    ,
                  if(err==4||err==132) Sleep(1000*60);                           // 4-  , 132- 
                  if(err==141) Sleep(1000*10);                                   // 141-  
                  if(err==146) while(IsTradeContextBusy()) Sleep(1000*10);      // 146-  
                 }
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+    
string Error(int error_code)
  {
   string error_string;
   switch(error_code)
     {
      case 0:   error_string=" ";                                                     break;
      case 1:   error_string=" ,   ";                            break;
      case 2:   error_string=" ";                                                   break;
      case 3:   error_string=" ";                                         break;
      case 4:   error_string="  ";                                          break;
      case 5:   error_string="   ";                            break;
      case 6:   error_string="    ";                                  break;
      case 7:   error_string=" ";                                              break;
      case 8:   error_string="  ";                                         break;
      case 9:   error_string="    ";      break;
      case 64:  error_string=" ";                                              break;
      case 65:  error_string="  ";                                       break;
      case 128: error_string="    ";                          break;
      case 129: error_string=" ";                                              break;
      case 130: error_string=" ";                                             break;
      case 131: error_string=" ";                                             break;
      case 132: error_string=" ";                                                   break;
      case 133: error_string=" ";                                             break;
      case 134: error_string="    ";                     break;
      case 135: error_string=" ";                                                break;
      case 136: error_string=" ";                                                        break;
      case 137: error_string=" ";                                                   break;
      case 138:
         error_string="  Ask="+DoubleToStr(Ask,Digits)+" Bid="+DoubleToStr(Bid,Digits); break;
      case 139: error_string="    ";                        break;
      case 140: error_string="  ";                                       break;
      case 141: error_string="  ";                                         break;
      case 145: error_string=" ,       ";    break;
      case 146: error_string="  ";                                     break;
      case 147: error_string="     ";         break;
      case 148: error_string="      ,  .";break;
      case 4000: error_string=" ";                                                      break;
      case 4001: error_string="  ";                                  break;
      case 4002: error_string="  -  ";                                  break;
      case 4003: error_string="    ";                                    break;
      case 4004: error_string="    ";                    break;
      case 4005: error_string="      ";                     break;
      case 4006: error_string="    ";                             break;
      case 4007: error_string="    ";                                 break;
      case 4008: error_string=" ";                                     break;
      case 4009: error_string="   ";                           break;
      case 4010: error_string="    ";                               break;
      case 4011: error_string="  ";                                          break;
      case 4012: error_string="    ";                                      break;
      case 4013: error_string="  ";                                                 break;
      case 4014: error_string=" ";                                             break;
      case 4015: error_string=" ";                                            break;
      case 4016: error_string=" ";                                     break;
      case 4017: error_string=" DLL  ";                                         break;
      case 4018: error_string="  ";                                 break;
      case 4019: error_string="  ";                                      break;
      case 4020: error_string="     ";                break;
      case 4021: error_string="   ,   ";         break;
      case 4022: error_string=" ";                                                  break;
      case 4050: error_string="   ";                      break;
      case 4051: error_string="   ";                         break;
      case 4052: error_string="   ";                             break;
      case 4053: error_string=" ";                                                  break;
      case 4054: error_string="  -";                    break;
      case 4055: error_string="  ";                             break;
      case 4056: error_string=" ";                                            break;
      case 4057: error_string="   ";                         break;
      case 4058: error_string="   ";                             break;
      case 4059: error_string="     ";                          break;
      case 4060: error_string="  ";                                            break;
      case 4061: error_string="  ";                                           break;
      case 4062: error_string="   string";                                  break;
      case 4063: error_string="   integer";                                 break;
      case 4064: error_string="   double";                                  break;
      case 4065: error_string="    ";                           break;
      case 4066: error_string="     ";          break;
      case 4067: error_string="    ";                         break;
      case 4099: error_string=" ";                                                     break;
      case 4100: error_string="    ";                                      break;
      case 4101: error_string="  ";                                          break;
      case 4102: error_string="   ";                                   break;
      case 4103: error_string="  ";                                         break;
      case 4104: error_string="    ";                             break;
      case 4105: error_string="    ";                                         break;
      case 4106: error_string=" ";                                              break;
      case 4107: error_string="     ";                 break;
      case 4108: error_string="  ";                                           break;
      case 4109: error_string="  .         .";            break;
      case 4110: error_string="   .    .";           break;
      case 4111: error_string="   .    .";          break;
      case 4200: error_string="  ";                                           break;
      case 4201: error_string="   ";                          break;
      case 4202: error_string="  ";                                            break;
      case 4203: error_string="  ";                                         break;
      case 4204: error_string="  ";                                               break;
      case 4205: error_string="  ";                                        break;
      case 4206: error_string="   ";                                    break;
      default:   error_string="    ";
     }
   return(error_string);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double fCalculateLot(int typLot,int itt)
  {

   double newlot=0.0;int i;
   switch(typLot)
     {
      case 0: newlot=lot;break;
      case 1: newlot=itt*lot;break;
      case 2: for(i=1;i<=itt;i++)newlot+=i*lot;break;
      case 3:  if(itt==1)newlot=1*lot;if(itt==2)newlot=2*lot;if(itt==3)newlot=3*lot;if(itt==4)newlot=5*lot;if(itt==5)newlot=8*lot;
      if(itt==6)newlot=13*lot;if(itt==7)newlot=21*lot;if(itt==8)newlot=34*lot;if(itt==9)newlot=55*lot;if(itt==10)newlot=87*lot;
      if(itt==11)newlot=142*lot;if(itt==12)newlot=229*lot;if(itt==13)newlot=371*lot;if(itt==14)newlot=600*lot;if(itt==15)newlot=971*lot;
      break;
      default: Print("   ");
     }

   double maxlot=MarketInfo(Symbol(),MODE_MAXLOT);
   double minlot=MarketInfo(Symbol(),MODE_MINLOT);
   double steplot=MarketInfo(Symbol(),MODE_LOTSTEP);
   newlot=steplot*MathFloor(newlot/steplot);
   if(newlot<minlot)newlot=minlot;
   if(newlot>maxlot)newlot=maxlot;

   newlot=NormalizeDouble(newlot,RoundLot);

   return(newlot);
  }
//+------------------------------------------------------------------+
//|                                               |
//|_ticket - 0 ,                               |
//+------------------------------------------------------------------+
bool ModifyStopTake(int _ticket,double _Stop,double _Take)
  {
//ModifyStopTake(0,Stop,double _Take);
   bool   YesModify;
   double _Open=OrderOpenPrice();
   int    err,it;
   double _stplvl=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;

   if(_ticket>0)OrderSelect(_ticket,SELECT_BY_TICKET);
   if(NormalizeDouble(_Stop,Digits)==OrderStopLoss() && NormalizeDouble(_Take,Digits)==OrderTakeProfit())return(true);
   if(OrderType()==OP_BUY)
     {
      if(_Stop+_stplvl>OrderOpenPrice() && _Stop!=0 && _Stop!=OrderStopLoss())
         Print("BUY: ="+NormalizeDouble(_Stop,Digits)+" ="+NormalizeDouble(OrderOpenPrice(),Digits));
      if(_Take-_stplvl<OrderOpenPrice() && _Take!=0 && _Take!=OrderStopLoss())
         Print("BUY: ="+NormalizeDouble(_Take,Digits)+" ="+NormalizeDouble(OrderOpenPrice(),Digits));
        }else{//SELL
      if(_Stop-_stplvl<OrderOpenPrice() && _Stop!=0 && _Stop!=OrderStopLoss())
         Print("SELL: ="+NormalizeDouble(_Stop,Digits)+" ="+NormalizeDouble(OrderOpenPrice(),Digits));
      if(_Take+_stplvl>OrderOpenPrice() && _Take!=0 && _Take!=OrderStopLoss())
         Print("SELL: ="+NormalizeDouble(_Take,Digits)+" ="+NormalizeDouble(OrderOpenPrice(),Digits));
     }
//if (_Stop==0)_Stop=OrderStopLoss();if (_Take==0)_Take=OrderTakeProfit();
   for(it=1; it<=NumberOfTry; it++)
     {
      while(!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      YesModify=OrderModify(OrderTicket(),_Open,NormalizeDouble(_Stop,Digits),NormalizeDouble(_Take,Digits),0,Orange);
      if(YesModify)
        {
         if(YesModify && UseSound) {PlaySound(NameFileSound); return(true);}
           } else {
         err=GetLastError();
         Print("(",err,")  : ",Error(err),",  ",it);
         //Print(_Stop," ",_Take," ",Ask," ",Bid);
         Sleep(1000*PauseAfterError);
        }
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                             |
//| _ticket- ( 0    )                |                                              
//+------------------------------------------------------------------+
bool ModifyLimitOrder(int _ticket,double open,double _newstop,double _newtake)
  {
//ModifyLimitOrder(0/ticket,newprice,stop,take);
   bool   YesModify;
   int    err,it;
   if(_ticket>0)OrderSelect(_ticket,SELECT_BY_TICKET);
   for(it=1; it<=NumberOfTry; it++)
     {
      while(!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      YesModify=OrderModify(OrderTicket(),NormalizeDouble(open,Digits),NormalizeDouble(_newstop,Digits),
                            NormalizeDouble(_newtake,Digits),0,Orange);
      if(YesModify)
        {
         if(YesModify && UseSound) {PlaySound(NameFileSound); return(true);}
           } else {
         err=GetLastError();
         Print("(",err,")   : ",Error(err),",  ",it);
         Sleep(1000*PauseAfterError);
        }
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool fBarX(int _barx,string pos,int itime)
  {
   bool res=true;int start;double _MAT,_priceBuy,_priceSell;
   start=MathMin(itime,_barx);

   if(_barx!=0)
     {
      if(itime<_barx)res=false;else
        {
         if(pos=="SELL")
           {
            //Print(start);
            for(int i=start;i>=0;i--)
              {
               _MAT=iMA(Symbol(),TFT,pMAT,shiftMAT,typeMAT,priceMAT,i);
               _priceSell=iMA(Symbol(),TFH,pMAH,shiftMAH,typeMAH,priceMAH,i);
               //Print(_priceSell);
               _priceSell=_priceSell+pipsXH*Point;
               //Print(_priceSell," ",iLow(NULL,TF,i)," ",iHigh(NULL,TF,i)," ",Bid,">",MAT);
               if(((_priceSell<iLow(NULL,TFH,i) || _priceSell>iHigh(NULL,TFH,i)) && Bid>_MAT) || Bid<=_MAT)continue;else{res=false;break;}
              }

              }else{//BUY
            for(i=start;i>=0;i--)
              {
               _MAT=iMA(Symbol(),TFT,pMAT,shiftMAT,typeMAT,priceMAT,i);
               _priceBuy=iMA(Symbol(),TFL,pMAL,shiftMAL,typeMAL,priceMAL,i);
               _priceBuy=_priceBuy-pipsXL*Point;
               if(((_priceBuy<iLow(NULL,TFL,i) || _priceBuy>iHigh(NULL,TFL,i)) && Bid<_MAT) || Bid>=_MAT)continue;else{res=false;break;}
              }
           }
        }
     }

   return(res);
  }
//-----------------------------------------------------------------------------//
//|   :                                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//-----------------------------------------------------------------------------//
void ClosePositions(string sy="",int op=-1,int mn=-1)
  {
//ClosePositions(NULL,OP_BUY,-1);ClosePositions(NULL,OP_BUY,Magic);
   int i,k=OrdersTotal();
   if(sy=="0") sy=Symbol();
   for(i=k-1; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op))
           {
            if(OrderType()==OP_BUY || OrderType()==OP_SELL)
              {
               if(mn<0 || OrderMagicNumber()==mn) ClosePosBySelect();
              }
           }
        }
     }
  }
//  
void ClosePosBySelect()
  {
   bool   fc;
   color  clClose;
   double ll,pa,pb,pp;
   int    err,it;
// Print (OrderTicket());
   if(OrderType()==OP_BUY || OrderType()==OP_SELL)
     {
      for(it=1; it<=NumberOfTry; it++)
        {
         if(!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
         while(!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         pa=MarketInfo(OrderSymbol(), MODE_ASK);
         pb=MarketInfo(OrderSymbol(), MODE_BID);
         if(OrderType()==OP_BUY)
           {
            pp=pb; clClose=Green;
              } else {
            pp=pa; clClose=Orange;
           }
         ll=OrderLots();
         fc=OrderClose(OrderTicket(), ll, pp, Slippage, clClose);
         if(fc)
           {
            if(UseSound) PlaySound(NameFileSound); break;
              } else {
            err=GetLastError();
            if(err==146) while(IsTradeContextBusy()) Sleep(1000*11);
            Print("(",err,")  ",OrderType()," ",Error(err),",  ",it);
            Print(OrderTicket(),"  Ask=",pa,"  Bid=",pb,"  pp=",pp);
            Print("=",OrderSymbol(),"  =",ll,"  =",OrderStopLoss(),
                  "  =",OrderTakeProfit(),"  =",OrderMagicNumber());
            Sleep(1000*5);
           }
        }
     }
   else Print("  . Close ",OrderType());
  }
//+------------------------------------------------------------------+
